package com.franckbarbier._Programmable_thermostat_MODEL._Programmable_thermostat;

public class Run_indicator /* implements java.io.Serializable */ {
//    public static final String Status = "Run indicator status";
//    private String status;
//    private java.beans.PropertyChangeSupport propertySupport;

    /**
     * UML control flow
     */
    protected Run_indicator_output _programmable_thermostat;
    /**
     * UML state machine diagram
     */
    public static String Everything_off = "Everything off";

    private com.pauware.pauware_engine.Core.AbstractState _Everything_off;
    private com.pauware.pauware_engine.Core.AbstractState _Something_on;
    private com.pauware.pauware_engine.Core.AbstractStateMachine _Run_indicator_state_machine;

    /**
     * UML creation
     */
    private void init_structure(Run_indicator_output programmable_thermostat) throws com.pauware.pauware_engine.Exceptions.State_exception {
        _programmable_thermostat = programmable_thermostat;
    }

    private void init_behavior() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _Everything_off = new com.pauware.pauware_engine.Core.State(Everything_off);
        _Everything_off.inputState();
        _Something_on = new com.pauware.pauware_engine.Core.State("Something on");
        _Run_indicator_state_machine = new com.pauware.pauware_engine.Core.StateMachine(_Everything_off.xor(_Something_on), "Run indicator", com.pauware.pauware_engine.Core.AbstractStateMachine.Don_t_show_on_system_out);
    }

    public void start() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _Run_indicator_state_machine.fires("off", _Something_on, _Everything_off);
        _Run_indicator_state_machine.fires("on", _Everything_off, _Something_on);
        _Run_indicator_state_machine.start();
    }

    public Run_indicator(Run_indicator_output programmable_thermostat) throws com.pauware.pauware_engine.Exceptions.State_exception {
        init_structure(programmable_thermostat);
        init_behavior();
//        status = getStatus();
//        propertySupport = new java.beans.PropertyChangeSupport(this);
//        propertySupport.addPropertyChangeListener(programmable_thermostat);
    }

    /**
     * JavaBeans component model not supported by Java ME
     */
    /* private String getStatus() {
     return _Run_indicator_state_machine.current_state();
     }
     private void setStatus(String newValue) {
     String oldValue = status;
     status = newValue;
     propertySupport.firePropertyChange(Status,oldValue,newValue);
     }
     private void addPropertyChangeListener(java.beans.PropertyChangeListener listener) {
     propertySupport.addPropertyChangeListener(listener);
     }
     private void removePropertyChangeListener(java.beans.PropertyChangeListener listener) {
     propertySupport.removePropertyChangeListener(listener);
     } */
    /**
     * UML events
     */
    public void off() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _Run_indicator_state_machine.run_to_completion("off");
        // setStatus(_Run_indicator_state_machine.current_state());
        _programmable_thermostat.propertyChange(_Run_indicator_state_machine.current_state());
    }

    public void on() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _Run_indicator_state_machine.run_to_completion("on");
        // setStatus(_Run_indicator_state_machine.current_state());
        _programmable_thermostat.propertyChange(_Run_indicator_state_machine.current_state());
    }
}
