package com.franckbarbier._Programmable_thermostat_MODEL._Relays;

public class Fan_relay extends Relay {

    /**
     * UML state machine diagram
     */
    private com.pauware.pauware_engine.Core.AbstractState _Fan_off;
    private com.pauware.pauware_engine.Core.AbstractState _Fan_on;
    private com.pauware.pauware_engine.Core.AbstractStateMachine _Fan_relay_state_machine;

    /**
     * UML creation
     */
    protected void init_behavior() throws com.pauware.pauware_engine.Exceptions.State_exception {
        super.init_behavior();
        _Fan_off = (_Is_off.name("Fan off")).set_entryAction(this, "disactivate");
        _Fan_off.inputState();
        _Fan_on = (_Is_on.name("Fan on")).set_entryAction(this, "activate");
        _Fan_relay_state_machine = (com.pauware.pauware_engine.Core.AbstractStateMachine) _Relay_state_machine.name("Fan relay");
    }

    public void start() throws com.pauware.pauware_engine.Exceptions.State_exception {
        super.start();
    }

    public Fan_relay() throws com.pauware.pauware_engine.Exceptions.State_exception {
        init_behavior();
    }

    /**
     * UML events
     */
    public void stop() throws com.pauware.pauware_engine.Exceptions.State_exception {
        // Inherited from 'Relay' without added value here...
    }

    public void stop(Boolean guard) throws com.pauware.pauware_engine.Exceptions.State_exception {
        _Fan_relay_state_machine.fires("stop", _Fan_on, _Fan_off, guard.booleanValue());
        _Fan_relay_state_machine.run_to_completion("stop");
    }

    /**
     * UML actions
     */
    public void activate() {
    }

    public void disactivate() {
    }
}
