 module Programmable_thermostat {
    /**
     * 'transitive' allows the access to 'javafx.application.Application'
     * and 'javafx.stage.Stage' coming from 'javafx.graphics' module:
     */
    requires transitive javafx.controls; // 'javafx.base' and 'javafx.graphics' are transitively included...
    /**
     * https://stackoverflow.com/questions/62659576/illegalaccessexception-cannot-access-class-c-in-module-m-because-module-m-doe
     * JavaFX is based on reflection, so:
     */
    opens com.franckbarbier._Programmable_thermostat_GUI to javafx.graphics;
    // 'opens' to FXML if it is used...
    requires PauWareTwo;
    // This applies for actions called by reflection by PauWareTwo:
    opens com.franckbarbier._Programmable_thermostat_MODEL._Programmable_thermostat to PauWareTwo;
    opens com.franckbarbier._Programmable_thermostat_MODEL._Relays to PauWareTwo;
    opens com.franckbarbier._Temperature to PauWareTwo;
    requires PauWare2Web;
}
