package com.franckbarbier._Programmable_thermostat_MODEL._Switchs;

public class Fan_switch implements Fan_switch_input {

    /**
     * UML control flow
     */
    private Fan_switch_output _programmable_thermostat;
    /**
     * UML state machine diagram
     */
    private com.pauware.pauware_engine.Core.AbstractState _Is_auto;
    private com.pauware.pauware_engine.Core.AbstractState _Is_on;
    private com.pauware.pauware_engine.Core.AbstractStateMachine _Fan_switch_state_machine;

    /**
     * UML creation
     */
    private void init_structure(Fan_switch_output programmable_thermostat) throws com.pauware.pauware_engine.Exceptions.State_exception {
        _programmable_thermostat = programmable_thermostat;
    }

    private void init_behavior() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _Is_auto = new com.pauware.pauware_engine.Core.State("Is auto");
        _Is_auto.inputState();
        _Is_on = new com.pauware.pauware_engine.Core.State("Is on");
        _Fan_switch_state_machine = new com.pauware.pauware_engine.Core.StateMachine(_Is_auto.xor(_Is_on), "Fan switch", com.pauware.pauware_engine.Core.AbstractStateMachine.Don_t_show_on_system_out/*, new com.pauware.pauware2web.PauWare2Web_client()*/);
    }

    public void start() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _Fan_switch_state_machine.fires("auto", _Is_on, _Is_auto);
        _Fan_switch_state_machine.fires("on", _Is_auto, _Is_on, true, _programmable_thermostat, "fan_switch_turned_on");
        _Fan_switch_state_machine.start();
    }

    public Fan_switch(Fan_switch_output programmable_thermostat) throws com.pauware.pauware_engine.Exceptions.State_exception {
        init_structure(programmable_thermostat);
        init_behavior();
    }

    /**
     * UML events
     */
    public void auto() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _Fan_switch_state_machine.run_to_completion("auto");
    }

    public void on() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _Fan_switch_state_machine.run_to_completion("on");
    }

    /**
     * UML <in>
     */
    public boolean in(String name) {
        return _Fan_switch_state_machine.in_state(name);
    }
}
